package com.liang.service;

import com.liang.entity.BaseSubjectname;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;

import java.util.List;
import java.util.Map;

/**
 * (BaseSubjectname)表服务接口
 *
 * @author makejava
 * @since 2023-03-04 10:54:02
 */
public interface BaseSubjectnameService {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    BaseSubjectname queryById(String id);

    /**
     * 分页查询
     *
     * @param baseSubjectname 筛选条件
     * @param pageRequest     分页对象
     * @return 查询结果
     */
    Page<BaseSubjectname> queryByPage(BaseSubjectname baseSubjectname, PageRequest pageRequest);

    /**
     * 新增数据
     *
     * @param baseSubjectname 实例对象
     * @return 实例对象
     */
    BaseSubjectname insert(BaseSubjectname baseSubjectname);

    /**
     * 修改数据
     *
     * @param baseSubjectname 实例对象
     * @return 实例对象
     */
    BaseSubjectname update(BaseSubjectname baseSubjectname);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 是否成功
     */
    boolean deleteById(String id);

    /**
     * 获取所有数据
     *
     * @return
     */
    List<BaseSubjectname> queryAll();

    /**
     * 查询满足条件的记录
     *
     * @param id
     * @return
     */
    List<BaseSubjectname> queryListById(String id);

    /**
     * 获取学科分类列表
     *
     * @return
     */
    List<Map<String, String>> getSubjectList();
}
